//-------------------------------------------------------------------------------------
//	dummy_12ax7_v06.h
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
//	Phil le   31/01/2013  
//-------------------------------------------------------------------------------------







//-------------------------------------------------------------------------------------
#ifndef base_h
#define base_h
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
//	definitions et constantes
//-------------------------------------------------------------------------------------

#define F_CPU 			16000000UL		//frequence quartz

#define SET_NUL 		0   //commande nulle
#define SET_STOP 		1   //commande arret
#define GET_VERS 		2  //retourne la version du prog

#define SET_VA_max 		3   //VA_max
#define SET_VG2_max 	4   //VG2_max
#define SET_VG1_max 	5   //VG1_max
#define SET_VFIL_max 	6   //VFIL_max

#define SET_VA_min 		7   //VA_min
#define SET_VG2_min 	8   //VG2_min
#define SET_VG1_min 	9   //VG1_min
#define SET_VFIL_min 	10   //VFIL_min

#define SET_VA 			11   //VA
#define SET_VG2 		12   //VG2
#define SET_VG1 		13   //VG1
#define SET_VFIL 		14   //VFIL

#define MESURE 			15   //MESURE


#define ncom 			16		//nombre de commandes possibles

#define mes_VA			1		//canal ADC de mesure
#define mes_VG1			2		//canal ADC de mesure
#define mes_VG2			3		//canal ADC de mesure
#define mes_IA			4		//canal ADC de mesure
#define mes_IG1			5		//canal ADC de mesure
#define mes_IG2			6		//canal ADC de mesure
#define mes_VFIL		7		//canal ADC de mesure

#define reg_VA			1		//port pour regler la tension
#define reg_VG1			2		//port pour regler la tension
#define reg_VG2			3		//port pour regler la tension
#define reg_VFIL		4		//port pour regler la tension

//-------------------------------------------------------------------------------------
//includes
//-------------------------------------------------------------------------------------

#include <avr/io.h>
#include</home/phil/ATMEL/atmel/avr/include/util/delay.h>
//#include</home/phil/ATMEL/atmel/avr/include/util/twi.h>
#include</home/phil/ATMEL/atmel/avr/include/avr/interrupt.h>
//#include</home/phil/ATMEL/avr-libc-1.4.4/doc/examples/demo/iocompat.h>
#include</home/phil/ATMEL/avr-libc-1.4.4/include/math.h>
#include</home/phil/ATMEL/avr-libc-1.4.4/include/string.h>

//-------------------------------------------------------------------------------------
//variables globales
//-------------------------------------------------------------------------------------

//tableau de pointeur de fonctions
void (*pf[ncom])(float);

//VA_max 
volatile float VA_max;

//VG2_max 
volatile float VG2_max;

//VG1_max 
volatile float VG1_max;

//VFIL_max 
volatile float VFIL_max;

//VA_min 
volatile float VA_min;

//VG2_min 
volatile float VG2_min;

//VG1_min 
volatile float VG1_min;

//VFIL_min 
volatile float VFIL_min;

//VA 
volatile float VA;

//VG2 
volatile float VG2;

//VG1 
volatile float VG1;

//VFIL 
volatile float VFIL;

//attente
volatile uint8_t attente;

//afficheur
volatile uint8_t afficheur;

//sens
volatile uint8_t sens;

//valeur flottante
volatile float valeur_flottante;

//message
//volatile char mess[50];
char mess[50];

//-------------------------------------------------------------------------------------
//routines
//-------------------------------------------------------------------------------------

//main
int main(void);

//courant du tube 12ax7
uint8_t courant(float va,float vg,float *ia);

void fonc_void(float v);
void arret(float v);
void version(float v);

void set_VA_max(float v);
void set_VG2_max(float v);
void set_VG1_max(float v);
void set_VFIL_max(float v);

void set_VA_min(float v);
void set_VG2_min(float v);
void set_VG1_min(float v);
void set_VFIL_min(float v);

void set_VA(float v);
void set_VG2(float v);
void set_VG1(float v);
void set_VFIL(float v);

void mesure(float v);



void chenille(void);

void delai(uint16_t d);

//trace_ent
void trace_ent(int v,int s);

//trace_dec
void trace_dec(int v,int nd);

//initialisation transmission rs232
void rs232_init(unsigned char baud,unsigned char isr_rx);

//reception
unsigned char rs232_rx_8(void);

//emission
void rs232_tx_8(unsigned char v);

//emission d'une valeur quelconque
void rs232_tx_valeur(float v,int nd);

//emission d'un code retour
void rs232_tx_retour(uint8_t v);

//reception d'une valeur quelconque
uint8_t rs232_rx_valeur(void);

//emission d'une chaine
void rs232_tx_chaine(uint8_t l,char *c);

//-------------------------------------------------------------------------------------
#endif
//-------------------------------------------------------------------------------------
